// Project is hosted at https://github.com/OneAndOnlyOdin/VMasterSexScriptsClient and provided under the MIT licence

// using webapp-stage. for testing purposes use https://webapp.odinsmaster.com/... for production use
final apiURL = "https://webapp.odinsmaster.com/VMasterCore/index.php"
final placeholderUsername = ""
final placeholderPassword = ""
final LOG_LEVEL = 0

// ---------------------- Dont change anything bellow here -----------------------------

final ENCODING_UTF8 = "UTF-8"
final LOG_DEBUG = 5

final log = { msg, level ->
	if (LOG_LEVEL < level) {
		return null
	}
	if (level == LOG_DEBUG) {
		getSelectedValue("DEBUG: "+msg, ["Go on.."])	
	}
}

final logDebug = { msg ->
	log(msg, LOG_DEBUG)
}

final convertUTF8ToUTF16 = { utf8string ->
	return new String(utf8string.getBytes(ENCODING_UTF8))
}

final jsonRPC2Request = { url, requestId, method, params ->
	final post = new URL(apiURL).openConnection();
	final p = groovy.json.JsonOutput.toJson(params)
	final queryString = '{"json-rcp": "2.0", "id": "'+requestId+'", "method": "'+method+'", "params": '+p+'}'
	logDebug("The query string is: "+queryString)
	post.setRequestMethod("POST")
	post.setDoOutput(true)
	post.setRequestProperty("Content-Type", "application/json")
	post.getOutputStream().write(queryString.getBytes(ENCODING_UTF8));
	final postRC = post.getResponseCode();
	//println(postRC);
	if(postRC.equals(200)) {
		final utf8encodedText = post.getInputStream().getText(ENCODING_UTF8)
		final text = convertUTF8ToUTF16(utf8encodedText)
	    logDebug(text);
		
		final jsonSlurper = new groovy.json.JsonSlurper()
		try {
			final object = jsonSlurper.parseText(text)
			return object
		} catch (Exception ex) {
			logDebug("json parsing failed")
			// looks like its not valid json
			return null
		}
	
	}
	return null
}


final rpc = { method, params ->
	return jsonRPC2Request(apiURL, 42, method, params)
}

final login = {
	final username = getString("What is your username?", placeholderUsername)
	final password = getString("What is your password?", placeholderPassword)

	final features = ["insecure-html"]
	final fields = ["master.name"]
	final request = rpc("login", [username, password, features, fields])
	if (request) {
		return request.result
	}

	return null
}

final sendUserInput = { sessionId, text ->	
	return rpc("processUserInput", ["userInput": text, "sessionId": sessionId, "messageId": "DummyMessageId"])
}

final pickupNextMessage = { sessionId ->
	return rpc("nextMessage", [sessionId])
}

final sendUserInputAndPickupNextMessage = { sessionId, text ->
	final sendInputRequest = sendUserInput(sessionId, text).result
	if (sendInputRequest == true) {
		return pickupNextMessage(sessionId)
	}
	return null
}

// See https://stackoverflow.com/questions/19764834/recursion-with-closures-in-groovy-2-1-9 for why the ugly definition
def messageLoop
messageLoop = { sessionId, userInput ->
	final request = sendUserInputAndPickupNextMessage(sessionId, userInput)
	if (request) {
		final message = request.result.message
		final expectedInputType = request.result.expected_user_input_type

		// See https://odinsmaster.com/2019/08/write-a-client-for-your-master/ for documentation
		switch (expectedInputType) {
			case "choice_index":
				final choices = request.result.choices
				final index = getSelectedValue(message, choices)
				messageLoop(sessionId, index)
				break

			default:
				final input = getString(message, "")
				messageLoop(sessionId, input ? input : ".")
				break
		}
	}
}


setInfos(1, "Odin's Master", "A client for odinsmaster.com.",
	"OneAndOnlyOdin", "1.1", 0xDADFDF, "en", [
												"internet",
												"game",
												"toys",
												"formale",
												"forfemale",
												"bondage",
												"femaledom",
												"maledom",
												"pain",
												"android",
												"sissy",
												"orgasmcontrol",
												"options",
												"anal",
												"urine"
											])


// TODO: Check if user is already provided credentials

final menu = getSelectedValue("Welcome to Odin's Master. Please login with your credentials or register at https://webapp.odinsmaster.com",
	["Login", "Register"])

if (menu == 0) {
	final loginResult = login()
	if (!loginResult) {
		show("Something went wrong login in. Please make sure your username password combination was correct")
	}
	if (loginResult) {
		final sessionId = loginResult.sessionId
		show("Logging in..")
		messageLoop(sessionId, ".")
	}
}
if (menu == 1) {
	useUrl("https://webapp.odinsmaster.com")
}